;	(2013.10.29 Revision 13)

	LIST		P=PIC10F322
	#INCLUDE	<P10F322.inc>

	__CONFIG	_FOSC_INTOSC & _BOREN_OFF & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _LVP_OFF & _LPBOR_OFF & _BORV_HI & _WRT_OFF

        #define TX      2               ;\tgEGAVA TX Data output pin (i.e. 2 = RA2)
        #define RX      3               ;\tgEGAVA RX Data input pin  (i.e. 3 = RA3)
        #define Direct_TX               ;RS-232C TX Direct Connection (MAX232gpȂ)
        #define Direct_RX               ;RS-232C RX Direct Connection (MAX232gpȂ)
;
; ********************************************************************
;  	RAM̐ݒ (64 bytes maximum ; 40h-7fh)
;       Bank 0 Only
; ********************************************************************

        cblock 0x7D
	tmp_W		;0x7D [NWX^
	cn		;0x7E \tgEGAVAA|vJE^[
	rxd		;0x7F \tgEGAVAAMf[^obt@[
        endc

;/////////////////////////////////////////////////////////////////
;
;		vOR[h
;
;/////////////////////////////////////////////////////////////////

		ORG	0x0000
INIT:
		bcf	OPTION_REG,T0CS	; RA2sI/Osɐݒ
		clrf    ANSELA          ; RAnsfW^o͂ɐݒ

   #ifdef Direct_TX
		bcf	LATA,TX
   #else
		bsf	LATA,TX
   #endif
                bcf     TRISA,TX        ; TXs̃x(H/L)ݒATXso͂ɐݒ

start:
		CALL	CRLF		;s
		MOVLW	MES001		;R}hCbZ[W\
		CALL	PUT2
cmd_select:
		call	GETC		;R}h (R}h͏)
		movlw	'w'
		subwf	rxd,w
		skpnz
		goto	w_command
		movlw	'r'
		subwf	rxd,w
		skpnz
		goto	r_command
		movlw	'e'
		subwf	rxd,w
		skpnz
		goto	e_command
		movlw	'i'
		subwf	rxd,w
		skpz
		goto	cmd_select

i_command:				;<initial(all clear)>
		call	PUTCW		;R}hGR[obN
		call	initial_eeprom	;INITIAL EEPROM
		goto	exit_command

r_command:				;<read>
		call	get_adress	;R}h\AwAhXGR[obN
		call	read_eeprom	;READ EEPROM
		movlw	'x'		;Xe[^X\
		btfss	flag,6		;'-'ȂwAhX̃f[^݂
		movlw	'-'		;'x'ȂwAhX̃f[^܂ĂȂB
		call	PUTC
		movf	EE_DAT,w
		call	PUTHEX2		;wAhX̃f[^\
		goto	exit_command

e_command:				;<erase>
		call	get_adress	;R}h\AwAhXGR[obN
		call	erase_eeprom	;ERASE EEPROM
		goto	exit_command

w_command:				;<write>
		call	get_adress	;R}h\AwAhXGR[obN
		call	r_c2
		movf	rxd,w
		movwf	tmp_W
		call	PUTHEX		;wAhX̃f[^(H)GR[obN
		call	r_c2
		swapf	tmp_W,w
		addwf	rxd,w
		movwf	EE_DAT
		call	PUTHEX		;wAhX̃f[^(L)GR[obN
		call	write_eeprom	;WRITE EEPROM
exit_command:
		call	CRLF		;s
		call	DRW_TBL		;[_v\
		call	CRLF		;s
		goto	start		;R}h͂ɖ߂

; ********************************************************************
;		bZ[W
; ********************************************************************

MES000:					;[_v̍ŏ̍s
 DW	0x0d*0x80+0x0A			;s
 DW	'A'*0x80+'D'			;ADRS +000 +001 +002 +003 +004 +005 +006 +007
 DW	'R'*0x80+'S'			;
 DW	' '*0x80+'+'			;
 DW	'0'*0x80+'0'			;
 DW	'0'*0x80+' '			;
 DW	'+'*0x80+'0'			;
 DW	'0'*0x80+'1'			;
 DW	' '*0x80+'+'			;
 DW	'0'*0x80+'0'			;
 DW	'2'*0x80+' '			;
 DW	'+'*0x80+'0'			;
 DW	'0'*0x80+'3'			;
 DW	' '*0x80+'+'			;
 DW	'0'*0x80+'0'			;
 DW	'4'*0x80+' '			;
 DW	'+'*0x80+'0'			;
 DW	'0'*0x80+'5'			;
 DW	' '*0x80+'+'			;
 DW	'0'*0x80+'0'			;
 DW	'6'*0x80+' '			;
 DW	'+'*0x80+'0'			;
 DW	'0'*0x80+'7'			;
 DW	0x0d*0x80+0x0A			;s
 DW	0				;bZ[WGh

MES001:					;R}hCbZ[W
 DW	'E'*0x80+'r'			;Erase[eaa], Read[raa], Write[waadd], Init[i] (aa:address/dd:data, hex2)
 DW	'a'*0x80+'s'			;->
 DW	'e'*0x80+'['			;
 DW	'e'*0x80+'a'			;
 DW	'a'*0x80+']'			;
 DW	','*0x80+' '			;
 DW	'R'*0x80+'e'			;
 DW	'a'*0x80+'d'			;
 DW	'['*0x80+'r'			;
 DW	'a'*0x80+'a'			;
 DW	']'*0x80+','			;
 DW	' '*0x80+'W'			;
 DW	'r'*0x80+'i'			;
 DW	't'*0x80+'e'			;
 DW	'['*0x80+'w'			;
 DW	'a'*0x80+'a'			;
 DW	'd'*0x80+'d'			;
 DW	']'*0x80+','			;
 DW	' '*0x80+'I'			;
 DW	'n'*0x80+'i'			;
 DW	't'*0x80+'['			;
 DW	'i'*0x80+']'			;
 DW	' '*0x80+'('			;
 DW	'a'*0x80+'a'			;
 DW	':'*0x80+'a'			;
 DW	'd'*0x80+'d'			;
 DW	'r'*0x80+'e'			;
 DW	's'*0x80+'s'			;
 DW	'/'*0x80+'d'			;
 DW	'd'*0x80+':'			;
 DW	'd'*0x80+'a'			;
 DW	't'*0x80+'a'			;
 DW	','*0x80+' '			;
 DW	'h'*0x80+'e'			;
 DW	'x'*0x80+'2'			;
 DW	')'*0x80+0x0D			;
 DW	0x0A*0x80+'-'			;s
 DW	'>'*0x80+0			;bZ[WGh

; ********************************************************************
;		Tu[`
; ********************************************************************

; --------------------------------------------------------------------
;		R}hEEROMAhX擾ăGR[obN
; --------------------------------------------------------------------

get_adress:
		call	PUTCW		;R}hGR[obN
r_c1:
		call	r_c2		;EEROMAhX(H)擾
		movlw	b'11111100'
		andwf	rxd,w
		skpz
		goto	r_c1		;EEROMAhX(H) > 3@ȂĎ擾

		movf	rxd,w		;tmp_W Ɏ擾lZbg
		movwf	tmp_W
		call	PUTHEX		;EEROMAhX(H)GR[obN

		call	r_c2		;EEROMAhX(L)擾
		swapf	tmp_W,w		;EE_ADRZbg
		addwf	rxd,w		;EE_ADR = (tmp_W<<4)+rxd
		movwf	EE_ADR
		goto	PUTHEX		;EEROMAhX(L)GR[obN

r_c2:
		call	GETHEX		;1擾 (HEXϊς)
		btfsc	rxd,7
		goto	r_c2		;HEXlłȂ΍ē
		return

; --------------------------------------------------------------------
;
;		1(ASCII)͂āAHEXlɕϊ
;
;		:rxd, o rxd, ͕HEXlłȂƂ:rxd,7=1
;
; --------------------------------------------------------------------

GETHEX:
	call	GETC			;ASCII擾

	MOVLW	'0'
	SUBWF	rxd,f
	SKPC
	GOTO	not_hex

	MOVLW	'9'+1-'0'		;0_9
	SUBWF	rxd,w
	SKPC
	RETURN

	MOVLW	'f'+1-'0'
	SUBWF	rxd,w
	SKPNC
	GOTO	not_hex

	MOVLW	'a'-'0'
	SUBWF	rxd,w
	SKPC
	GOTO	not_hex

	MOVLW	0x27			;a_f
	SUBWF	rxd,f			;rxd=rxd-0x27
	RETURN

not_hex:
	BSF	rxd,7
	RETURN

; --------------------------------------------------------------------
;		[_v\
; --------------------------------------------------------------------

DRW_TBL:
	MOVLW	MES000			;ŏ̍s\
	CALL	PUT2

	MOVLW	0x01			;Set PMADRH
	MOVWF	PMADRH
	MOVLW	0x80			;Set Adress low
	MOVWF	FSR

LOOP1:					;2sڈȍ~̏
	MOVLW	b'00111111'		;FSR = 0x80 or 0xC0?
	ANDWF	FSR,w
	SKPNZ
	CALL	LINE44			;'--------------'\
	MOVF	PMADRH,W		;ʃAhX\
	CALL	PUTHEX2
	MOVF	FSR,W			;ʃAhX\
	CALL	PUTHEX2
LOOP2:
	MOVLW	" "			;󔒂\
	CALL	PUTC
	MOVF	FSR,W			;PMADRL=FSR
	MOVWF	PMADRL
	CALL	rd			;tbV1[hǂݏo
	MOVF	PMDATH,W		;PMDATH\
	CALL	PUTHEX2
	MOVF	PMDATL,W		;PMDATL\
	CALL	PUTHEX2
	INCF	FSR,F			;FSR=FSR+1
	BTFSS	FSR,7			;FSR=0x00?
	RETURN				;^[

	MOVLW	b'00000111'		;FSR=B'XXXXX000'?
	ANDWF	FSR,w
	SKPZ
	GOTO	LOOP2

	CALL	CRLF			;FSR=B'XXXXX000'
	GOTO	LOOP1			;s

; --------------------------------------------------------------------
;		tbVɏ܂ꂽbZ[W\
; --------------------------------------------------------------------

PUT2
	MOVWF	PMADRL			;PMADRZbg
	CLRF	PMADRH
LOOP_P
	CALL	rd			;tbV1[hǂݏo
	INCF	PMADRL,F		;PMADRL = PMADRL + 1
	RLF	PMDATL,F		;Carry=a, PMDATL=bcdefghX
	RLF	PMDATH,W		;Carry=0, W=0ABCDEFa
	RRF	PMDATL,F		;Carry=X, PMDATL=0bcdefgh
	CALL	PUTC			;ŏ̕\
	MOVF	PMDATL,W		;W=PMDATL
	skpnz				;W>0
	RETURN				;^[

	CALL	PUTC			;̕\
	GOTO	LOOP_P			;[v

; --------------------------------------------------------------------
;		'-----------------------------------'
; --------------------------------------------------------------------

LINE44:
	MOVLW	.44			;tmp_W = 44
	MOVWF	tmp_W
	MOVLW	'-'			;'-'\
	CALL	PUTC
	decfsz	tmp_W,f
	GOTO	$-3			;[v

; --------------------------------------------------------------------
;		s
; --------------------------------------------------------------------

CRLF:
	MOVLW	0x0D
	CALL	PUTC
	MOVLW	0x0A
	GOTO	PUTC

; --------------------------------------------------------------------
;
;		HEXl2ŕ\
;
;		:W
;
; --------------------------------------------------------------------

PUTHEX2:
	MOVWF	tmp_W			;tmp_W=W
	SWAPF	tmp_W,w			;4bitƉ4bit
	CALL	PUTHEX			;1\
	MOVF	tmp_W,W			;rxd=tmp_W
PUTHEX:
	ANDLW	B'00001111'		;W=B'00001111'
	MOVWF	rxd			;rxd="0000XXXX"
	MOVLW	0x0A			;W=0x0A
	SUBWF	rxd,W			;W=rxd-W
	MOVLW	0x30			;
	BTFSC	STATUS,C		;W<0x0A
	ADDLW	0x27			;
	ADDWF	rxd,W			;

; --------------------------------------------------------------------
;
;		RS-232C 1byte M
;
;		:W  ߂l:W=0x09, Carry=1, Zero=1
;
; --------------------------------------------------------------------

PUTC:
		movwf   rxd             ; rxd=w
PUTCW:
		movlw	.10		; cn=10(1+8+1)
		movwf	cn		;
		bcf	STATUS,C	; Carry=0

        #ifdef  Direct_TX
                btfsc   STATUS,C	; Bit Output
                bcf     PORTA,TX        ;
                btfss   STATUS,C	;
                bsf     PORTA,TX	;
        #else
                btfsc   STATUS,C	; Bit Output
                bsf     PORTA,TX	;
                btfss   STATUS,C	;
                bcf     PORTA,TX        ;
        #endif

                call    bwait           ; wait 1bit and Carry=1
		rrf     rxd,f		; set Carry
                decfsz  cn,f            ; send 10bits?
                goto    $-7		; loop

bwait:					; wait 1 bit
		call	bwait2		; 1 us  total:1+49+49=99 us
bwait2:					; wait 1/2bit and Set Carry=1
		movlw   .256-.24	; 0.5 us
                addlw   0x01           	; 0.5 us
                btfss	STATUS,Z        ; 0.5 us
                goto    $-2             ; 1 us
		retlw	0x09		; 1 us  total:0.5+(0.5+0.5+1)*24-0.5+1=49 us

; --------------------------------------------------------------------
;
;		RS-232C 1byte@M
;
;		߂l:W=Mf[^, rxd=Mf[^
;
; --------------------------------------------------------------------

GETC:
        #ifdef  Direct_RX
                btfss   PORTA,RX
        #else
                btfsc   PORTA,RX
        #endif
                goto	$-1		; wait Start bit

		call    bwait2          ; wait 1/2 bit and W=9
                movwf   cn		; cn=9
                rrf     rxd,f		; get bit data
		call    bwait           ; wait 1 bit and set Carry=1

        #ifdef  Direct_RX
                btfsc   PORTA,RX
        #else
                btfss   PORTA,RX
        #endif

                bcf     STATUS,C

		decfsz	cn,f		; cn=0?
                goto    $-5		; loop
                movf    rxd,w           ; return in w
                return






;/////////////////////////////////////////////////////////////////
;
;	PIC16F/12F/10FpEEPROM G~[V TuvO
;
;		(2013.10.29 Revision 10)
;
;	<t@NV>
;	1.initial_eeprom	EEPROM̈̏AS0xFFށB
;	2.read_eeprom		wAhX̃f[^EE_DATɕԂB
;	3.erase_eeprom		wAhX̃f[^B
;	4.write_eeprom		f[^wAhXɏށB
;
;	0x00=<EE_ADR<0x3F	EEPROMAhX(6rbg)
;	0x00=<EE_DAT=<0xFF	EEPROMf[^(8rbg)
;
;	<gp@>
;	1	call	initial_eeprom
;
;	2	movwf	EE_ADR
;		call	read_eeprom
;
;	3	movwf	EE_ADR
;		call	erase_eeprom
;
;	4	movwf	EE_ADR
;		movwf	EE_DAT
;		call	write_eeprom
;
;	<[h/CgXe[^X>
;	read/write status    ---->   ͈͊ÕAhXw肵		flag,7=1 
;	read status          ---->   wAhXɃf[^݂Ȃ	flag,6=1 
;
;	[]
;	@call initial_eeprom 
;
;	@߂l: EE_ADR=ێ, EE_DAT=ێ, flag=0x00
;
;	AEE_ADR=0x44, EE_DAT=0x42, call write_eeprom 
;
;	@߂l: EE_ADR=0x44(ێ), EE_DAT=0x42(ێ), flag=0x80 ȂŖ߂
;
;	BEE_ADR=0x3F, call read_eeprom 
;
;	@߂l: EE_ADR=0x3F(ێ), EE_DAT=ێ, flag=0x80 ȂŖ߂
;
;	CEE_ADR=0x25, EE_DAT=0x42, call write_eeprom 
;
;	@߂l: EE_ADR=0x25(ێ)܂0x3F, EE_DAT=s, flag=0x00 ݎ{
;
;	DEE_ADR=0x22, call read_eeprom 
;
;	@EEPROM(0x22) ݍς(=0x37)̂Ƃ@߂l: EE_DAT=0x37, EE_ADR=0x22(ێ), flag=0x00
;
;	@EEPROM(0x22) ς(=0xFF)̂Ƃ      ߂l: EE_DAT=0xFF, EE_ADR=0x22(ێ), flag=0x00
;
;	@EEPROM(0x22) ݑÔƂ	    ߂l: EE_DAT=0xFF, EE_ADR=0x22(ێ), flag=0x40
;
;/////////////////////////////////////////////////////////////////

; --------------------------------------------------------------------
;		RAM̐ݒ
; --------------------------------------------------------------------
;
        cblock	0x70
	  EE_ADR			;EEPROM Address (0x00=<EE_ADR<0x3F)
	  EE_DAT			;EEPROM Data    (8bits)
	  flag				;read/write status, address error :flag,7=1
	endc				;read status,       data not exist:flag,6=1

r_flag	equ	EE_ADR
count	equ	flag
tmp_adr	equ	flag

; --------------------------------------------------------------------
;		foCXɂݒ
; --------------------------------------------------------------------

;PMADRH	equ	EEADRH		;PMADRH݂ȂƂRg
;PMADRL	equ	EEADRL		;
;PMDATH	equ	EEDATH		;
;PMDATL	equ	EEDATL		;
;PMCON1	equ	EECON1		;
;PMCON2	equ	EECON2		;
;
;   +-------------+-------------------+----------+	|		|
;   |   Device    | PMADRH/L,PMADRH/L | PMCON1/2 |	| PIC16F/12F/10F|
;   +-------------+-------------------+----------+	|		|
;   |  PIC10F32X  |       BANK 0      |  BANK 0  |	+---------------+EETOP +
;   +-------------+-------------------+----------+	|		|      |
;   |  PIC12F617  |       BANK 1      |  BANK 1  |	|  Sub Program  |      |EESIZE
;   +-------------+-------------------+----------+	|		|      |
;   |  PIC16F72X  |       BANK 2      |  BANK 3  |	+---------------+PAGE0 +
;   +-------------+-------------------+----------+	|     PAGE0	|      |PWIDTH
;   |  PIC16F75X  |       BANK 3      |  BANK 3  |	+---------------+PAGE1 +
;   +-------------+-------------------+----------+	|     PAGE1	|      |PWIDTH
;   |  PIC16F1XXX |       BANK 3  @@|  BANK 3  |	+---------------+      +
;   +-------------+-------------------+----------+	|		|
;
#define	EPSIZE	0x10			;y[W̑傫 ([h)A[U[Y}jAQƂ̂
#define	BNK	0			;PMADRH/LPMDATH/LzuĂoN(0/1/2/3)
;
#define	EETOP	0x0100			;TuvO̊Jnʒu
#define	EESIZE	0x80			;TuvÕTCY
#define	PWIDTH	0x40			;EEPROMy[WTCY
#define	PAGE0	EETOP+EESIZE		;EEPROM Page0
#define	PAGE1	EETOP+EESIZE+PWIDTH	;EEPROM Page1


		ORG	EETOP

; ********************************************************************
;
;		Initial EEPROM
;
; ********************************************************************

initial_eeprom:
		call	set_PAGE0		;PMADR = PAGE0
		movlw	2*PWIDTH/EPSIZE		;count = 2*PWIDTH/EPSIZE
		goto	erase_page10		;y[W0ƃy[W1

; ********************************************************************
;
;		Read EEPROM
;
; ********************************************************************

read_eeprom:
		call	set_pointer		;y[WIAwAhX`FbN
		btfsc	flag,7
		return				;G[^[

		call	read_data		;wAhX̃f[^ǂݏo
		clrf	flag			;Xe[^XtONA
		btfss	r_flag,6		;wAhX̃f[^݂
		bsf	flag,6			;wAhX̃f[^݂Ȃ
		bcf	r_flag,6		;r_flag,6NA
		goto	all_ret			;^[

; ********************************************************************
;
;		Erase EEPROM
;
; ********************************************************************

erase_eeprom:
		movlw	0xFF			;EE_DAT = 0xFF
		movwf	EE_DAT

; ********************************************************************
;
;		Write EEPROM
;
; ********************************************************************

write_eeprom:
		call	set_pointer		;y[WIAwAhX`FbN
		btfsc	flag,7
		return				;G[^[

		movf	PMADRL,w		;tmp_adr = PMADRL
		movwf	tmp_adr

write_eeprom_data:
		call	rd			;y[W̃f[^ǂݏo
		movlw	0x3F			;W = PMDATH - 0x3F
		subwf	PMDATH,w
		skpz				;f[^܂ĂȂ
		goto	next_data		;f[^܂Ă

		movf	EE_ADR,w		;PMDATH = EE_ADR
		movwf	PMDATH
		movf	EE_DAT,w		;PMDATL = EE_DAT
		movwf	PMDATL
		call	wr_w			;f[^
		goto	check_eeprom

next_data:
		incf	PMADRL,f		;PMADRL = PMADRL + 1
		goto	write_eeprom_data	;̃f[^ǂݏo

check_eeprom:
		incf	PMADRL,w		;W = AND(PMADRL+1,b'00111111')
		andlw	b'00111111'
		skpz				;ݏꏊy[W̍ŌȂXLbv
		goto	clr_status		;ݏꏊy[W̍ŌłȂ΃^[

copy_eeprom:					;݂̃y[W̃f[^ĕʂ̃y[WɃRs[
		clrf	EE_ADR			;EE_ADR = 0

copy_data:
		movf	tmp_adr,w		;PMADRRs[y[W̐擪ɐݒ
		andlw	b'11000000'
		movwf	PMADRL
		call	read_data		;EEPROMf[^擾
		btfss	r_flag,6		;f[^݂
		goto	no_data			;f[^݂͑Ȃ

		bcf	r_flag,6		;clear flag
		movf	tmp_adr,w		;PMADRL = Rs[y[W
		xorlw	PWIDTH
		movwf	PMADRL
		movf	EE_ADR,w		;PMDATH = EE_ADR
		movwf	PMDATH
		movf	EE_DAT,w		;PMDATL = EE_DAT
		movwf	PMDATL
		incf	tmp_adr,f		;tmp_adr = tmp_adr + 1
		call	wr_w			;EEPROMf[^Rs[̃y[WɃRs[

no_data:
		incf	EE_ADR,f		;EE_ADR = EE_ADR + 1
		movlw	0x3F			;W = EE_ADR - 0x3F
		subwf	EE_ADR,w
		skpz				;f[^Rs[
		goto	copy_data		;̃f[^Rs[

		movf	tmp_adr,w		;PMADRRs[y[W̐擪ɐݒ
		andlw	b'11000000'
		movwf	PMADRL

erase_page:					;y[W
		movlw	PWIDTH/EPSIZE		;count = PWIDTH/EPSIZE
erase_page10:
		movwf	count
erase_loop:
		call	wr_e			;y[WTCY
		movlw	EPSIZE			;PMADRL = PMADRL + EPSIZE
		addwf	PMADRL,f
		decfsz	count,f
		goto	erase_loop
clr_status:
		clrf	flag			;Xe[^XtONA
all_ret:					;SẴt@NV̏o
		clrf	STATUS			;BANK 0
		return


;/////////////////////////////////////////////////////////////////
;
;		Tu[`
;
;/////////////////////////////////////////////////////////////////

; --------------------------------------------------------------------
;
;		PMADRLy[W̐擪ɐݒ
;		AhX͈͊OȂAflag,7ZbgĖ߂
;
; --------------------------------------------------------------------

set_pointer:
		clrf	flag			;Xe[^XtONA
		movlw	0x3F			;W=EE_ADR-0x3F
		subwf	EE_ADR,w
		skpnc				;EE_ADR < 0x3F
		bsf	flag,7			;Xe[^XtOZbg
		movlw	(PAGE1 & 0xFF)		;PMADRy[W1̐擪ɐݒ
		call	set_PAGE10

		call	rd			;y[W1̐擪f[^ǂݏo
		movlw	0x3F			;W = PMDATH - 0x3F
		subwf	PMDATH,w
		skpz				;y[W1͖gp
		return				;^[

set_PAGE0:
		movlw	(PAGE0 & 0xFF)		;PMADRy[W0̐擪ɐݒ
set_PAGE10:					;SẴt@NV͂ʉ߂̂
						;oN̐؂ւōsȂB
	#IF BNK==3
		bsf	STATUS,RP0		;BANK3
		bsf	STATUS,RP1
	#ENDIF
	#IF BNK==2
		bcf	STATUS,RP0		;BANK2
		bsf	STATUS,RP1		;BANK2̏ꍇ̂PMCON1/2̃oN3ƂȂB
	#ENDIF
	#IF BNK==1
		bsf	STATUS,RP0		;BANK1
		bcf	STATUS,RP1
	#ENDIF
		movwf	PMADRL
		movlw	((PAGE0>>8) & 0xFF)
		movwf	PMADRH

	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		clrf	PMCON1			;PMCON1NA
	#IF BNK==2
		bcf	STATUS,RP0	; BANK2
	#ENDIF

		return				;^[

; --------------------------------------------------------------------
;
;	EE_ADRŎw肳ꂽAhXōŌɏ܂ꂽf[^擾
;
;		  : PMADR, EE_ADR
;		߂l: EE_DAT, f[^݂Ƃr_flag,6Zbg
;
; --------------------------------------------------------------------

read_data:
		bcf	r_flag,6	;clear r_flag
		movlw	0xFF		;EE_DAT̏l=0xFF
		movwf	EE_DAT
rd_loop:
		call	rd		;1[hǂݏo
		movf	EE_ADR,w	;W = PMDATH(<0x40)
		andlw	b'00111111'	;
		subwf	PMDATH,w	;W = PMDATH - W
		skpz			;AhXEE_ADRƈv
		goto	$+4		;AhXEE_ADRƈvȂ

		movf	PMDATL,w	;EE_DATɒlZbg
		movwf	EE_DAT
		bsf	r_flag,6	;r_flag,6Zbg

		incf	PMADRL,f	;PMADRL = PMADRL + 1
		movlw	b'00111111'
		andwf	PMADRL,w
		skpz			;y[W̍ŌɓB烊^[
		goto	rd_loop
		return

; --------------------------------------------------------------------
;
;		tbV̓ǂݏo//
;
;		o: PMADRH/L, PMDATH/L
;
; --------------------------------------------------------------------

wr_e:					; y[WTCY
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,FREE
wr_w:					; 1[h
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,WREN
		movlw   0x55
                movwf   PMCON2
                movlw   0xaa
                movwf   PMCON2
		bsf	PMCON1,WR
rd:					; 1[hǂݏo
	#IF BNK==2
		bsf	STATUS,RP0	; BANK3
	#ENDIF
		bsf	PMCON1,RD
                nop
                nop
		clrf	PMCON1
	#IF BNK==2
		bcf	STATUS,RP0	; BANK2
	#ENDIF
		return

; ********************************************************************

		org	0x0180

; DW 0x35ac , 0x00f5 , 0x0036 , 0x2856 , 0x339f , 0x15d4 , 0x0478 , 0x3ecc
; DW 0x0743 , 0x3c80 , 0x3532 , 0x00e3 , 0x10ff , 0x09cd , 0x1f56 , 0x2478
; DW 0x38cf , 0x2850 , 0x1d67 , 0x2165 , 0x0c83 , 0x1c9f , 0x1734 , 0x3032
; DW 0x1234 , 0x1520 , 0x36ca , 0x2c49 , 0x0c78 , 0x29fa , 0x0866 , 0x1035
; DW 0x2468 , 0x0b56 , 0x0735 , 0x33ff , 0x3729 , 0x3b49 , 0x0d45 , 0x26bd
; DW 0x1f65 , 0x2107 , 0x3030 , 0x0b54 , 0x2b44 , 0x0a68 , 0x2e67 , 0x1e3d
; DW 0x2e7e , 0x1188 , 0x1457 , 0x3d3e , 0x0dec , 0x0a0d , 0x3c6f , 0x0e55
; DW 0x25ff , 0x2edc , 0x3942 , 0x2019 , 0x2222 , 0x13df


        	END
